/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: standing_order.h 5780 2008-05-12 06:37:55Z jz $        Joacim Zschimmer, Zschimmer GmbH, http://www.zschimmer.com 

#ifndef __SCHEDULER_STANDING_ORDER_H
#define __SCHEDULER_STANDING_ORDER_H

namespace sos {
namespace scheduler {
namespace order {

////--------------------------------------------------------------------------------------------const
//
//extern const char               folder_name_separator;
//
////-----------------------------------------------------------------------------------Standing_order
//
//struct Standing_order : file_based< Standing_order, Standing_order_folder, Standing_order_subsystem >,
//                        Object
//{
//                                Standing_order              ( Standing_order_subsystem* );
//                               ~Standing_order              ();
//
//
//    // Scheduler_object
//
//    void                        close                       ();
//  //string                      obj_name                    () const;
//
//
//    // file_based<>
//
//    STDMETHODIMP_(ULONG)        AddRef                      ()                                      { return Object::AddRef(); }
//    STDMETHODIMP_(ULONG)        Release                     ()                                      { return Object::Release(); }
//
//    void                        set_name                    ( const string& );
//    void                    set_dom                         ( const xml::Element_ptr& );
//    xml::Element_ptr            dom_element                 ( const xml::Document_ptr&, const Show_what& );
//
//  //bool                        on_requisite_to_be_removed  ( File_based* );
//
//    bool                        on_initialize               (); 
//    bool                        on_load                     (); 
//    bool                        on_activate                 ();
//
//    bool                        can_be_removed_now          ();
//    void                        on_remove_now               ();
//
//
//    //
//
//    Standing_order_folder*      standing_order_folder       () const                                { return typed_folder(); }
//    string                      job_chain_name              () const                                { return _job_chain_name; }
//    string                      order_id                    () const                                { return _order_id; }
//
//    
//  private:
//    bool                        order_is_removable_or_replaceable();
//  //void                        set_order                   ( Order* );
//
//
//    Fill_zero                  _zero_;
//    string                     _job_chain_name;
//    Absolute_path              _job_chain_path;
//    string                     _order_id;
//    ptr<Order>                 _order;
//    bool                       _its_me_removing;
//};
//
////----------------------------------------------------------------------------Standing_order_folder
//
//struct Standing_order_folder : typed_folder< Standing_order >
//{
//                                Standing_order_folder       ( Folder* );
//                               ~Standing_order_folder       ();
//
//
//  //void                        set_dom                     ( const xml::Element_ptr& );
//  //void                        execute_xml_standing_order  ( const xml::Element_ptr& );
//  //xml::Element_ptr            dom_element                 ( const xml::Document_ptr&, const Show_what& );
//    xml::Element_ptr            new_dom_element             ( const xml::Document_ptr& doc, const Show_what& )  { return doc.createElement( "standing_orders" ); }
//
//    void                        add_standing_order          ( Standing_order* standing_order )      { add_file_based( standing_order ); }
//    void                        remove_standing_order       ( Standing_order* standing_order )      { remove_file_based( standing_order ); }
//    Standing_order*             standing_order              ( const string& name )                  { return file_based( name ); }
//    Standing_order*             standing_order_or_null      ( const string& name )                  { return file_based_or_null( name ); }
//};
//
////-------------------------------------------------------------------------Standing_order_subsystem
//
//struct Standing_order_subsystem : file_based_subsystem< Standing_order >,
//                                  Object
//{
//                                Standing_order_subsystem    ( Scheduler* );
//
//    // Subsystem
//
//    void                        close                       ();
//    bool                        subsystem_initialize        ();
//    bool                        subsystem_load              ();
//    bool                        subsystem_activate          ();
//
//
//
//    // File_based_subsystem
//
//    string                      object_type_name            () const                                { return "Standing_order"; }
//    string                      filename_extension          () const                                { return ".order.xml"; }
//    void                        assert_xml_element_name     ( const xml::Element_ptr& ) const;
//    string                      xml_element_name            () const                                { return "order"; }
//    string                      xml_elements_name           () const                                { assert(0), z::throw_xc( Z_FUNCTION ); }
//    string                      normalized_name             ( const string& ) const;
//    ptr<Standing_order>         new_file_based              ();
//    xml::Element_ptr            new_file_baseds_dom_element ( const xml::Document_ptr& doc, const Show_what& ) { return doc.createElement( "standing_orders" ); }
//
//
//    ptr<Standing_order_folder>  new_standing_order_folder   ( Folder* folder )                      { return Z_NEW( Standing_order_folder( folder ) ); }
//
//
//    Standing_order*             standing_order              ( const Absolute_path& path ) const     { return file_based( path ); }
//    Standing_order*             standing_order_or_null      ( const Absolute_path& path ) const     { return file_based_or_null( path ); }
//
//  //xml::Element_ptr            execute_xml                 ( Command_processor*, const xml::Element_ptr&, const Show_what& );
//};
//
//inline ptr<Standing_order_subsystem> new_standing_order_subsystem( Scheduler* scheduler )           { return Z_NEW( Standing_order_subsystem( scheduler ) ); }

//-------------------------------------------------------------------------------------------------

} //namespace order
} //namespace scheduler
} //namespace sos

#endif
